import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

public class EchoClient {

    private static final Logger LOG = Logger.getLogger(EchoServer.class.getName());

    private Socket clientSocket;
    private PrintWriter out;
    private BufferedReader in;

    public void startConnection(String ip, int port) {
        try {
            clientSocket = new Socket(ip, port);
            out = new PrintWriter(clientSocket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
        } catch (IOException e) {
            LOG.log(Level.SEVERE, "Error when initializing connection", e);
        }

    }

    public String sendMessage(String msg) {
        try {
            out.println(msg);
            return in.readLine();
        } catch (Exception e) {
            return null;
        }
    }

    public void stopConnection() {
        try {
            in.close();
            out.close();
            clientSocket.close();
        } catch (IOException e) {
            LOG.log(Level.SEVERE, "error when closing", e);
        }
    }

    public static void main(String[] args) {
        EchoClient client = new EchoClient();
        client.startConnection("127.0.0.1", 4444);
        String resp1 = client.sendMessage("echo..");
        String resp2 = client.sendMessage("end");
        System.out.println(resp1);
        System.out.println(resp2);
        client.stopConnection();
    }
}
